/**
 * Simple horizontal movement
 * @moduleName MoveSimple
 * @snippet MoveSimple.snippet
MoveSimple({
    
})
 */
bento.define('components/movesimple', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/entity',
    'bento/eventsystem',
    'bento/utils',
    'bento/tween'
], function (
    Bento,
    Vector2,
    Rectangle,
    Entity,
    EventSystem,
    Utils,
    Tween
) {
    'use strict';
    return function (settings) {
        var viewport = Bento.getViewport();
        var entity;
        var component = {
            name: 'moveSimple',
            start: function (data) {},
            destroy: function (data) {},
            update: function (data) {
                entity.position.x -= 4 * data.speed;
            },
            draw: function (data) {},
            attached: function (data) {
                entity = data.entity;
            }
        };
        return component;
    };
});