/**
 * Module that indicates where the player should spawn, does nothing and is only used by maploader
 * @moduleName PlayerSpawn
 */
bento.define('entities/playerspawn', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/components/clickable',
    'bento/entity',
    'bento/eventsystem',
    'bento/gui/clickbutton',
    'bento/gui/counter',
    'bento/gui/text',
    'bento/utils',
    'bento/tween'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Clickable,
    Entity,
    EventSystem,
    ClickButton,
    Counter,
    Text,
    Utils,
    Tween
) {
    'use strict';
    return function (settings) {
        var viewport = Bento.getViewport();
        var position = settings.position;
        var behavior = {
            name: 'removeSelf',
            start: function () {
                entity.removeSelf();
            }
        };
        var entity = new Entity({
            name: 'playerSpawn'
        });
        return entity;
    };
});