/**
 * Badge on topright of buttons
 * @moduleName Badge
 * @snippet Badge.snippet
Badge({
    position: new Vector2(0, 0)
})
 */
bento.define('gui/badge', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/components/clickable',
    'bento/entity',
    'bento/eventsystem',
    'bento/gui/clickbutton',
    'bento/gui/counter',
    'bento/gui/text',
    'bento/utils',
    'bento/tween'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Clickable,
    Entity,
    EventSystem,
    ClickButton,
    Counter,
    Text,
    Utils,
    Tween
) {
    'use strict';
    return function (settings) {
        var viewport = Bento.getViewport();
        var position = settings.position;
        var sprite = new Sprite({
            imageName: 'ui/button-notification',
            originRelative: new Vector2(0.5, 0.5)
        });
        var entity = new Entity({
            name: 'badge',
            position: new Vector2(96, -96),
            components: [
                sprite
            ]
        });
        return entity;
    };
});