/**
 * Module for toggling music
 * @moduleName ToggleMusic
 */
bento.define('gui/buttons/togglemusic', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/components/clickable',
    'bento/entity',
    'bento/gui/togglebutton',
    'bento/gui/counter',
    'bento/gui/text',
    'bento/eventsystem',
    'bento/utils',
    'bento/tween'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Clickable,
    Entity,
    ToggleButton,
    Counter,
    Text,
    EventSystem,
    Utils,
    Tween
) {
    'use strict';
    return function (settings) {
        /*settings = {
            // describe your settings object parameters
            position: Vector2 // positions the entity
        }*/
        var viewport = Bento.getViewport();
        var toggleMusic = new ToggleButton({
            name: 'toggleMusic',
            sfx: 'sfx_button',
            z: settings.z || 0,
            image: Bento.assets.getImage('settings/toggle-music'),
            position: settings.position || new Vector2(0, 0),
            frameCountX: 2,
            frameCountY: 1,
            updateWhenPaused: settings.updateWhenPaused || 0,
            toggled: Bento.saveState.load('muteMusic', false),
            family: settings.family || ['gui'],
            onToggle: function () {
                Bento.audio.muteMusic(this.isToggled(), true);
                Bento.saveState.save('muteMusic', this.isToggled());
                EventSystem.fire('onMute', {
                    muted: this.isToggled()
                });
                EventSystem.fire('GameAnalytics-custom', {
                    id: 'settings:toggleMusic',
                    value: this.isToggled() ? 0 : 1
                });
            }
        });
        return toggleMusic;
    };
});