/**
 * Invisible button on the screen.
 * Dimenions are relative to the size of the viewport by default
 * @moduleName ClickableRegion
 * @snippet ClickableRegion.snippet
ClickableRegion({
    dimension: new Rectangle(0,0,1.0,1.0),
    onClickUp: function () {
    
    }
})
 */
bento.define('gui/clickableregion', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/components/clickable',
    'bento/entity'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Clickable,
    Entity
) {
    'use strict';
    return function (settings) {
        var viewport = Bento.getViewport();
        var r = settings.dimension;
        if (settings.usePixels !== true) {
            r = Rectangle(
                r.x*viewport.width, r.y*viewport.height,
                r.width*viewport.width, r.height*viewport.height);
        }
        return new Entity({
            float: true,
            dimension: r,
            components: [ new Clickable(settings) ]
        });
    };
});