/**
 * Overlay to show what the game will look like on an iPhone X
 * (make sure to set the game to iPhone X resolution in your browser dev tools)
 * @moduleName IPhoneXOverlay
 * @snippet IPhoneXOverlay.snippet
IPhoneXOverlay({})
 */
bento.define('gui/iphonexoverlay', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/entity',
    'bento/eventsystem',
    'bento/utils',
    'bento/tween',
    'globals'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Entity,
    EventSystem,
    Utils,
    Tween,
    Globals
) {
    'use strict';
    return function (settings) {
        var viewport = Bento.getViewport();
        var sprite = new Sprite({
            imageName: 'ui/iphone-x-overlay'
        });
        var entity = new Entity({
            z: Globals.Layers.IPHONE_X_OVERLAY,
            name: 'iPhoneXOverlay',
            updateWhenPaused: 0,
            float: true,
            global: true,
            components: [
                sprite,
                {
                    name: 'hide',
                    update: function () {
                        entity.visible = Utils.isWideScreen;
                        entity.scale.x = viewport.width / entity.dimension.width;
                        entity.scale.y = viewport.height / entity.dimension.height;
                    }
                }
            ]
        });
        return entity;
    };
});