/**
 * Bento wrapper for https://github.com/sarriaroman/FabricPlugin crashlytics
 * @moduleName Crashlytics
 *
 * @snippet Crashlytics.addLog|snippet
            Crashlytics.addLog('${1}');
 *
 * @snippet Crashlytics.sendCrash|snippet
            Crashlytics.sendCrash();
 * 
 * @snippet Crashlytics.sendNonFatalCrash|snippet
            Crashlytics.sendNonFatalCrash('Error message');
 * 
 * @snippet Crashlytics.setUserIdentifier|snippet
            Crashlytics.setUserIdentifier('123');
 * 
 * @snippet Crashlytics.setUserName|snippet
            Crashlytics.setUserName('Some Guy');
 * 
 * @snippet Crashlytics.setUserEmail|snippet
            Crashlytics.setUserEmail('some.guy@email.com');
 * 
 * @snippet Crashlytics.setStringValueForKey|snippet
            Crashlytics.setStringValueForKey('bar', 'foo');
 */
bento.define('modules/crashlytics', [
    'bento',
    'bento/eventsystem',
    'bento/utils'
], function (
    Bento,
    EventSystem,
    Utils
) {
    'use strict';

    var Crashlytics = window.fabric && window.fabric.Crashlytics;

    if (!Crashlytics) {
        console.log('Fabric Crashlytics not found');
        return null;
    }

    return Crashlytics;
});
