/**
 * Login to Google Play with game specific callback
 * @moduleName GooglePlayLogin
 * @snippet GooglePlayLogin|snippet
GooglePlayLogin(function () {});
 */
bento.define('modules/googleplaylogin', [
    'bento',
    'bento/utils',
    'modules/googleplay'
], function (
    Bento,
    Utils,
    GooglePlay
) {
    'use strict';
    return function (onComplete) {
        // remember that user agreed to login
        Bento.saveState.save('loginAttemptGooglePlay', true);

        // login to google play
        GooglePlay.login(function (hasLoggedIn) {
            var session;
            if (!window.Cocoon || !window.Cocoon.Social.GooglePlayGames) {
                // missing cocoon object
                if (onComplete) {
                    onComplete(false);
                }
                Utils.log('Warning: window.Cocoon object missing');
                return;
            }

            session = window.Cocoon.Social.GooglePlayGames.getSession();
            if (!session) {
                // no valid session
                if (onComplete) {
                    onComplete(false);
                }
                Utils.log('Warning: no valid session');
                return;
            }
            
            /*
            // try to retrieve the name
            if (Bento.saveState.load('localPlayerName', 'Guest') === 'Guest') {
                Bento.saveState.save('localPlayerName', session.playerAlias);
            }
            // set the player id here
            if (Bento.saveState.load('gameServiceID', null) === null) {
                Bento.saveState.save('gameServiceID', session.playerId);
            }

            // Automatically log into KTPlay
            Utils.KTPlayAutoLogin(function (user) {
                Utils.changeLocalNameToKTNickName();
            },function(error){
                console.log(error);
            });
            */

            // assumed to have logged in successfully
            if (onComplete) {
                onComplete(true);
            }
        });
    };
});