/**
 * Cheat menu :O
 */
bento.define('screens/cheatscreen', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/components/clickable',
    'bento/entity',
    'bento/eventsystem',
    'bento/gui/clickbutton',
    'bento/gui/counter',
    'bento/gui/text',
    'bento/utils',
    'bento/screen',
    'bento/tween',
    'bento/components/spine',
    'gui/speaker',
    'modules/expitems',
    'gui/gametext',
    'globals',
    'bento/components/fill',
    'gui/experiencebar',
    'entities/scoremanager',
    'gui/coincounter',
    'modules/localization',
    'managers/save',
    'bento/managers/savestate',
    'gui/buttons/home',
    'modules/crashlytics',
    'modules/mopub',
    'modules/cmplay'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Clickable,
    Entity,
    EventSystem,
    ClickButton,
    Counter,
    Text,
    Utils,
    Screen,
    Tween,
    Spine,
    Speaker,
    ExpItems ,
    GameText,
    Globals,
    Fill,
    ExperienceBar,
    ScoreManager,
    CoinCounter,
    Localization,
    SaveManager,
    SaveStateManager,
    HomeButton,
    Crashlytics,
    MoPub,
    CMPlay
) {
    'use strict';
    var onShow = function (settings) {
        var viewport = Bento.getViewport();
        var background = new Entity({
            z: 0,
            position: new Vector2(0, 0),
            components: [
                new Sprite({
                    imageName: 'shop/background',
                    frameCountX: 3,
                    animations: {
                        default: {
                            frames: [1] // take the middle frame for edge bleeding
                        }
                    }
                })
            ]
        });

        var buttonHome = new HomeButton({});

        var btnx = 200;
        var btny = 400;
        var cheatBtn = function (name, onClick) {
            Bento.objects.attach(new Entity({
                z: Globals.Layers.GUI,
                name: 'button',
                position: new Vector2(btnx, btny),
                scale: new Vector2(0.4, 0.4),
                components: [
                    new Sprite({
                        imageName: 'shop/button-purchase',
                        originRelative: new Vector2(0.5, 0.5),
                    }),
                    new GameText({
                        position: new Vector2(0, 0),
                        text: name,
                        fontSize: 100,
                        textBaseline: 'middle'
                    }),
                    new Clickable({
                        onClick: function () {
                            Bento.audio.stopSound('sfx_button');
                            Bento.audio.playSound('sfx_button');
                            onClick();
                            updateText();
                        }
                    })
                ]
            }));
            btny += 160;
        };

        var updateText = function () {
            coinText.setText(SaveManager.load('coins'));
            xpLevelText.setText(SaveManager.load('expLevel'));
            difficultyText.setText(Globals.STARTING_BOSSES_CLEARED);
        };


        cheatBtn('delete save', function () {
            SaveStateManager.clear();
        });

        var coinText = GameText({
            position: new Vector2(btnx+250, btny-22),
            text: SaveManager.load('coins'),
            fontSize: 40,
        });
        cheatBtn('+500 coins', function () {
            SaveManager.add('coins', 500);
        });

        var xpLevelText = GameText({
            position: new Vector2(btnx+250, btny-22),
            text: SaveManager.load('expLevel'),
            fontSize: 40,
        });
        cheatBtn('xp level up', function () {
            ScoreManager.expLevelUp();
        });

        cheatBtn('all fish', function () {
            var all = ["redfish", "bluefish", "coldfish", "greenfish", "koifish", "orangefish", "pufferfish", "silverfish", "taiyakifish", "billybassfish", "chipsfish", "clownfish", "killerfish", "paperfish", "radfish", "rainbowfish", "sushifish", "tigerfish", "arowanafish", "cakefish", "deadfish", "flappyfish", "ghostfish", "hellfish", "napoleonfish", "robotfish", "spiderfish", "blockyfish", "cartoonfish", "cyberfish", "godfish", "maorifish", "narwhalfish", "neonfish", "retrofish", "toyfish"];
            SaveManager.save('unlockedSkins', all);
            SaveManager.save('purchased-' + Utils.IapToId['epic1'], true);
            SaveManager.save('purchased-' + Utils.IapToId['epic2'], true);
        });

        var difficultyText = GameText({
            position: new Vector2(btnx+250, btny-22),
            text: Globals.STARTING_BOSSES_CLEARED,
            fontSize: 40,
        });
        cheatBtn('skip to boss', function () {
            Globals.STARTING_BOSSES_CLEARED += 1;
            Globals.STARTING_DISTANCE += 1000;
        });


        btny += 40;

        cheatBtn('dummy crash', function () {
            Crashlytics.addLog('Forcing a dummy crash from the cheat menu.');
            Crashlytics.sendCrash();
        });
        cheatBtn('GA crash', function () {
            Crashlytics.addLog('Forcing a GameAnalytics crash from the cheat menu.');
            window.GameAnalytics.addDesignEvent({
                eventId: 'dummyCrash',
                value: undefined  // <-- causes crash on Obj-C side due to poor validation
            });
        });
        cheatBtn('CMP crash', function () {
            Crashlytics.addLog('Forcing a CMPlay crash from the cheat menu.');
            window.CMPPromotionUtilsJs.echo('spaghetti'); // <-- causes crash on Java side due to not being in the GUI thread
        });


        btnx = 700;
        btny = 400;

        cheatBtn('banner ad', function () {
            MoPub.showBanner();
        });
        cheatBtn('interstitial', function () {
            MoPub.showInterstitial();
        });
        cheatBtn('reward video', function () {
            MoPub.showRewardVideo(function (didComplete) {
                if (didComplete) {
                    console.log('completed reward video! $$$');
                }
            });
        });


        cheatBtn('reset GDPR', function () {
            CMPlay.saveGDPRAgreedPrivacyPolicy(false);
            SaveManager.save('hasShownGDPRView', false);
        });

        cheatBtn('test GDPR', function () {
            Utils.timeout(0, function () {
                console.log('== checkIsGDPREnforcedCountry ==');
                CMPlay.checkIsGDPREnforcedCountry(function(res) {
                    console.log("result", res);
                    console.log('== done ==');
                }, function (res) {
                    console.log("error:", res);
                    console.log('== done ==');
                });
            });
            Utils.timeout(10, function () {
                console.log('== isAgreeGDPRPrivacyPolicy ==');
                CMPlay.isAgreeGDPRPrivacyPolicy(function(res) {
                    console.log("result", res);
                    console.log('== done ==');
                }, function (res) {
                    console.log("error", res);
                    console.log('== done ==');
                });
            });
            Utils.timeout(20, function () {
                console.log('== isAgreeGDPRAdStayInformed ==');
                CMPlay.isAgreeGDPRAdStayInformed(function(res) {
                    console.log("result", res);
                    console.log('== done ==');
                }, function (res) {
                    console.log("error", res);
                    console.log('== done ==');
            });
            });
            Utils.timeout(30, function () {
                console.log('== showGDPRView ==');
                CMPlay.showGDPRView(function(res) {
                    console.log("result", res);
                    console.log('== done ==');
                }, function (res) {
                    console.log("show gdpr error", res);
                    console.log('== done ==');
                });
            });
        });

        cheatBtn('grant consent', function () {
            MoPub.grantConsent();
        });
        cheatBtn('revoke consent', function () {
            MoPub.revokeConsent();
        });


        background.scale.x = viewport.width / background.dimension.width * 1.1;
        background.scale.y = viewport.height / background.dimension.height;
        Bento.objects.attach(background);
        Bento.objects.attach(buttonHome);
        Bento.objects.attach(coinText);
        Bento.objects.attach(xpLevelText);
        Bento.objects.attach(difficultyText);
        updateText();
    };

    var onHide = function () {

    };

    return new Screen({
        onShow: onShow,
        onHide: onHide
    });
});