/**
 * ads test
 */
bento.define('screens/testads', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/components/clickable',
    'bento/entity',
    'bento/eventsystem',
    'bento/gui/clickbutton',
    'bento/gui/counter',
    'bento/gui/text',
    'bento/utils',
    'bento/screen',
    'bento/tween',
    'gui/gametext',
    'bento/components/fill',
    'modules/mopub'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Clickable,
    Entity,
    EventSystem,
    ClickButton,
    Counter,
    Text,
    Utils,
    Screen,
    Tween,
    GameText,
    Fill,
    MoPub
) {
    'use strict';

    var onShow = function (settings) {
        var viewport = Bento.getViewport();

        var background = new Entity({
            z: 0,
            name: 'background',
            components: [
                new Fill({
                    color: [0, 0, 0, 1]
                })
            ]
        });
        Bento.objects.attach(background);

        var text = GameText({
            position: new Vector2(viewport.width*0.5, viewport.height*0.08),
            text: 'MoPub test',
            fontSize: 100,
        });
        Bento.objects.attach(text);


        var btnx = 220;
        var btny = 400;
        var makeBtn = function (name, onClick) {
            Bento.objects.attach(new Entity({
                position: new Vector2(btnx, btny),
                scale: new Vector2(0.5, 0.5),
                components: [
                    new Sprite({
                        imageName: 'shop/button-purchase',
                        originRelative: new Vector2(0.5, 0.5),
                    }),
                    new GameText({
                        position: new Vector2(0, 0),
                        text: name,
                        fontSize: 100,
                        textBaseline: 'middle'
                    }),
                    new Clickable({
                        onClick: function () {
                            onClick();
                        }
                    })
                ]
            }));
            btny += 170;
        };
        
        MoPub.showBanner();

        makeBtn('show interstitial', function () {
            if (MoPub.canShowInterstitial()) {
                MoPub.showInterstitial();
            }
        });
        makeBtn('show reward video', function () {
            if (MoPub.canShowRewardVideo()) {
                MoPub.showRewardVideo();
            }
        });
        
        btny += 80;

        makeBtn('go to title screen', function () {
            Bento.screens.show('screens/titlescreen');
        });
    };

    return new Screen({
        onShow: onShow
    });
});